import os
import math

def generate_mcfunction_file(radius, file_name="gen.mcfunction"):
    try:
        positions = []
        for x in range(-radius, radius + 1, 1):
            for y in range(-radius, radius + 1, 1):
                for z in range(-radius, radius + 1, 1):
                    distance = math.sqrt(x**2 + y**2 + z**2)
                    if distance <= radius:
                        positions.append((x, y, z))
        
        script_dir = os.path.dirname(os.path.realpath(__file__))
        file_path = os.path.join(script_dir, file_name)
        # Open the file in write mode, creating or replacing it
        with open(file_name, "w") as file:
            # Write the input string X number of times
            for _ in range(len(positions)):
                file.write(f"fillbiome ~{positions[_][0]} ~{positions[_][1]} ~{positions[_][2]} ~{positions[_][0]} ~{positions[_][1]} ~{positions[_][2]} minecraft:the_void\n")

        print(f"Successfully generated commands at 'gen.mcfunction'!")
    except Exception as e:
        print(f"An error occurred: {e}")

# Set the desired radius and resolution
generate_mcfunction_file(5)
